package org.xbib.interlibrary.ui;

import java.util.Objects;
import org.xbib.net.http.server.HttpRequest;
import org.xbib.net.http.server.application.Application;
import org.xbib.net.http.server.application.BaseApplicationModule;
import org.xbib.net.http.server.route.HttpRouterContext;
import org.xbib.net.http.server.service.HttpService;
import org.xbib.settings.Settings;

public class DatabasesApplicationModule extends BaseApplicationModule {

    public DatabasesApplicationModule(Application application, String name, Settings settings) {
        super(application, name, settings);
    }

    @Override
    public void onOpen(HttpRouterContext httpRouterContext, HttpService httpService, HttpRequest httpRequest) {
        DatabaseManagers databaseManagers = application.getAttributes().get(DatabaseManagers.class, "databasemanagers");
        Objects.requireNonNull(databaseManagers, "databasemanagers must not be null");
        httpRouterContext.getAttributes().put("databasemanagers", databaseManagers);
    }
}
