package org.xbib.interlibrary.ui.admin;

import org.xbib.interlibrary.ui.login.LoginController;
import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.j2html.J2HtmlResource;
import org.xbib.net.http.j2html.J2HtmlResourceHandler;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class UserSwitchController extends J2HtmlResourceHandler {

    private static final Logger logger = Logger.getLogger(UserSwitchController.class.getName());

    public UserSwitchController() {
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return httpRouterContext.isAuthenticated() ?
                new UserSwitchControllerResource(this, httpRouterContext) :
                new LoginController.LoginFormControllerResource(this, httpRouterContext);
    }

    public static class UserSwitchControllerResource extends J2HtmlResource {

        public UserSwitchControllerResource(HtmlTemplateResourceHandler templateResourceHandler,
                                            HttpRouterContext httpRouterContext)
                throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        @Override
        protected String renderHtml(HttpRouterContext context) throws ParameterException {
            UserSwitchView view = new UserSwitchView(this, application, request);
            return view.createPage(context, "Bibliothek wählen");
        }
    }
}
