package org.xbib.interlibrary.ui.dashboard;

import org.xbib.interlibrary.ui.login.LoginController;
import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.j2html.J2HtmlResource;
import org.xbib.net.http.j2html.J2HtmlResourceHandler;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

import java.io.IOException;

public class DashboardController extends J2HtmlResourceHandler {

    @Override
    protected Resource createResource(HttpRouterContext context) throws IOException, ParameterException {
        return context.isAuthenticated() ?
                new DashboardResource(this, context) :
                new LoginController.LoginFormControllerResource(this, context);
    }

    protected static class DashboardResource extends J2HtmlResource {

        protected DashboardResource(HtmlTemplateResourceHandler templateResourceHandler,
                                    HttpRouterContext httpRouterContext) throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        @Override
        protected String renderHtml(HttpRouterContext context) throws ParameterException {
            DashboardView view = new DashboardView(this, application, request);
            return view.createPage(context, "Hauptseite");
        }
    }
}
