package org.xbib.interlibrary.ui.login;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.UserProfile;
import org.xbib.net.http.j2html.J2HtmlResource;
import org.xbib.net.http.j2html.J2HtmlResourceHandler;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;
import org.xbib.net.http.server.session.Session;

import java.io.IOException;

public class LogoutController extends J2HtmlResourceHandler {

    public LogoutController() {
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new LogoutControllerResource(this, httpRouterContext);
    }

    public static class LogoutControllerResource extends J2HtmlResource {

        public LogoutControllerResource(HtmlTemplateResourceHandler templateResourceHandler,
                                        HttpRouterContext httpRouterContext)
                throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        @Override
        protected String renderHtml(HttpRouterContext context) throws ParameterException {
            UserProfile userProfile = context.getAttributes().get(UserProfile.class, "userprofile");
            // invalidate user profile
            userProfile.setUserId(null);
            userProfile.setEffectiveUserId(null);
            context.getAttributes().put("userprofile", userProfile);
            // remove session
            Session session = context.getAttributes().get(Session.class, "session");
            session.invalidate();
            seeOther(contextPath(context.getRequest(), "dashboard"));
            return "";
        }
    }
}
